/*
Portable ZX-Spectrum emulator.
Copyright (C) 2001-2020 SMT, Dexus, Alone Coder, deathsoft, djdron, scor

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package app.usp.fs;

import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


abstract class FileSelectorSourceHTML extends FileSelectorSourceWEB
{
	abstract public String[] Patterns();
	abstract public void PatternGet(List<Item> items, Matcher m, final String _name);
	@Override
	public GetItemsResult ParseText(final String _text, List<Item> items, final String _name, FileSelector.Progress progress)
	{
		boolean ok = false;
		for(String p : Patterns())
		{
			Pattern pt = Pattern.compile(p);
			Matcher m = pt.matcher(_text);
			while(m.find())
			{
				ok = true;
				PatternGet(items, m, _name);
			}
		}
		if(ok)
			return GetItemsResult.OK;
		return GetItemsResult.INVALID_INFO;
	}
}
