/*
Portable ZX-Spectrum emulator.
Copyright (C) 2001-2010 SMT, Dexus, Alone Coder, deathsoft, djdron, scor

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef	__TICK_H__
#define	__TICK_H__

#include "time2.h" // "time.h" magically conflicted with system <time.h> ??? seems this is clang precompiled headers bug

#pragma once

#ifdef _WINDOWS
#include "../platform/win/tick_qpc.h"
#endif//_WINDOWS

#if defined(_LINUX) || defined(_POSIX)
#include "../platform/linux/tick_gtod.h"
#endif//_LINUX

#ifdef _SYMBIAN
#include "../platform/symbian/tick.h"
#endif//_SYMBIAN

#ifndef TICK_DECLARED
#include "tick_clock.h"
#endif//TICK_DEFINED

#endif//__TICK_H__
